<?php

namespace Ems\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\{ Error, Message };

use Ems\Services\QuadroGeralVinculoService;

class QuadroGeralVinculoController {
    /** @var QuadroGeralVinculoService */
    protected $quadroGeralVinculoService;

    public function __construct(
        QuadroGeralVinculoService $quadroGeralVinculoService
    ) {
        $this->quadroGeralVinculoService = $quadroGeralVinculoService;
    }
    public function getQuadroGeralVinculo(
        Request\Row $request,
        Response $response
    ) {
        try {
            $row = $request->getRow()->getArrayCopy();

            $nrEstrutura = (int) $row['NRESTRUTURAM'];
            $nrPeriodo = (int) $row['NRPERIODOAPURACAO'];

            $quadroGeralVinculo = $this->quadroGeralVinculoService->getQuadroGeralVinculo(
                $nrEstrutura,
                $nrPeriodo
            );

            $response->addDataSet(new DataSet('getQuadroGeralVinculo', $quadroGeralVinculo));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace(), $e));
        }
    }
}