<?php

namespace Ems\Controllers;

use Exception\Messages;
use Service\LogService;
use Service\OAuth\OAuthCustomImpl;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO;


use Ems\Services\RescisaoService;

class RescisaoController {

    /** @var OcorrenciaService */
    protected $solicitacaoService;
    
    public function __construct(EntityManager $entityManager, RescisaoService $rescisaoService) {
        $this->entityManager        = $entityManager;
        $this->rescisaoService   = $rescisaoService;
    }
    
    public function getTpAvisoPrevio(Request\Row $request, Response $response) {
        try {

            $dados = $this->rescisaoService->getTpAvisoPrevio();

            $response->addDataSet(new DataSet('getTpAvisoPrevio', $dados));

        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
    
    public function getTpDemissao(Request\Row $request, Response $response) {
        try {

            $dados = $this->rescisaoService->getTpDemissao();

            $response->addDataSet(new DataSet('getTpDemissao', $dados));

        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
    
    public function getMotivoResc(Request\Row $request, Response $response) {
        try {

            $dados = $this->rescisaoService->getMotivoResc();

            $response->addDataSet(new DataSet('getMotivoResc', $dados));

        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }


}
