<?php

namespace Ems\Services;

use Util\Environment;
use Ems\Repository\ValeTransporteRepository;
use Util\NovoCodigo;

class ValeTransporteService {
    /** @var Environment */
    protected $environment;

    /** @var ValeTransporteRepository */
    protected $valeTransporteRepository;

    public function __construct(
        Environment                 $environment,
        ValeTransporteRepository    $valeTransporteRepository
    ) {
        $this->environment              = $environment;
        $this->valeTransporteRepository = $valeTransporteRepository;
    }

    public function setValeTransporte(
        array $row
    ): int {
        $nrOrg = (int) $this->environment->getNrOrg();
        $params = [];

        $params['NRLINHAVINC'] =
            $row['NRLINHAVINC'] ??
            NovoCodigo::geraCodigo($nrOrg, 'VAB_LINHAVINC', 1, 12, true, false);

        $params['NRLINHATARIFA']    = (int) $row['NRLINHATARIFA'];
        $params['NRVINCULOM']       = (int) $row['NRVINCULOM'];
        $params['NRTIPOLINHAVINC']  = (int) $row['NRTIPOLINHAVINC'];
        $params['NRSENTIDOLINHA']  = (int) $row['NRSENTIDOLINHA'];
        $params['DTINILINHAVINC']   = (string) $row['DTINILINHAVINC'];
        $params['DTFIMLINHAVINC']   = $row['DTFIMLINHAVINC'] ?? null;
        $params['QTLINHATARIFA']    = (int) $row['QTLINHATARIFA'];
        $params['DSOBSLINHAVINC']   = $row['DSOBSLINHAVINC'] ?? null;
        $params['IDATIVO']          = $row['IDATIVO'] ?? 'S';
        $params['NRORGINCLUSAO']    = $row['NRORGINCLUSAO'] ?? $nrOrg;
        $params['DTINCLUSAO']       = $row['DTINCLUSAO'] ?? date('d/m/Y');
        $params['CDOPERINCLUSAO']   = $row['CDOPERINCLUSAO'] ?? 1;
        $params['NRORGULTATU']      = $row['NRORGULTATU'] ?? null;
        $params['DTULTATU']         = $row['DTULTATU'] ?? null;
        $params['CDOPERULTATU']     = $row['CDOPERULTATU'] ?? null;
        $params['NRORG']            = $row['NRORG'] ?? $nrOrg;
        $params['NRINTEGTRANSPM']   = $row['NRINTEGTRANSPM'] ?? null;

        $this->valeTransporteRepository->setValeTransporte($params);

        return $params['NRLINHAVINC'];
    }
}