CREATE OR REPLACE PROCEDURE COMPRAS_PREVSVCOC(
P_LISTAPREVCOC IN VARCHAR2,
P_CIAS IN VARCHAR2,
P_CLASSES IN VARCHAR2,
P_CICLOS IN VARCHAR2,
P_DATACUSTO IN DATE,
P_TIPOCUSTO IN NUMBER,
P_NRPRODUCAOCOC IN OUT FLOAT
)
AS
V_NRPRODUCAOCOC VARCHAR2(20);
V_NRPRODPRODUCOC VARCHAR2(20);
V_QTBRUTA FLOAT;
V_VRYIELD FLOAT;
V_QTESTOQUE FLOAT;
V_VRCUSTOUNIT FLOAT;
V_VRCUSTOTOTAL FLOAT;
BEGIN
   IF P_NRPRODUCAOCOC IS NULL THEN
      NOVO_CODIGO_SC('PRODUCAOCOC',V_NRPRODUCAOCOC);
      P_NRPRODUCAOCOC := TO_NUMBER(V_NRPRODUCAOCOC);
   ELSE
      DELETE FROM PRODPRODUCOC WHERE NRPRODUCAOCOC = P_NRPRODUCAOCOC;
      DELETE FROM SUBRECPRODUCOC WHERE NRPRODUCAOCOC = P_NRPRODUCAOCOC;
      DELETE FROM RECPRODUCOC WHERE NRPRODUCAOCOC = P_NRPRODUCAOCOC;      
   END IF;
   
   /* Produtos da previso agregados(sem receita atrelada). Insere um a um*/
   FOR C_PRODUTOS IN
   (
      SELECT PV.CDFILIAL, P.CDPRODUTO, 
             ROUND(SUM(P.QTPRODPREVSVCOC), 3) AS QUANTIDADE,
             MAX(NVL(PO.VRPEFATOCORR, 0)) AS VRPEFATOCORR             
        FROM LISTA L
             INNER JOIN PREVSVCOC PV ON PV.NRPREVSVCOC = TO_NUMBER(L.CDLISTA)
             INNER JOIN PRODPREVSVCOC P ON P.NRPREVSVCOC = PV.NRPREVSVCOC
             INNER JOIN SERVPREVSVCOC S ON S.NRSERVPREVSVCOC = P.NRSERVPREVSVCOC
             INNER JOIN PRODUTO PO ON PO.CDPRODUTO = P.CDPRODUTO
       WHERE (P_CIAS = 'T' OR INSTR(P_CIAS, S.CDCIA) <> 0)
         AND (P_CLASSES = 'T' OR INSTR(P_CLASSES, S.CDCLASSE) <> 0)
         AND (P_CICLOS = 'T' OR INSTR(P_CICLOS, S.CDCICLO) <> 0)
         AND (P_LISTAPREVCOC = L.NRLISTA)
       GROUP BY P.CDPRODUTO, PV.CDFILIAL
   ) LOOP
      NOVO_CODIGO_SC('PRODPRODUCOC', V_NRPRODPRODUCOC);
      
      --Estoque do dia
      SELECT NVL(MAX(QTESTOQDIA), 0.0)
        INTO V_QTESTOQUE
        FROM POSESTDIA
       WHERE CDFILIAL = C_PRODUTOS.CDFILIAL
         AND CDPRODUTO = C_PRODUTOS.CDPRODUTO
         AND DTPOSIESTQ = (                   

         SELECT NVL(MAX(P.DTPOSIESTQ), NULL)
           FROM POSESTDIA P
          WHERE (P.CDFILIAL = C_PRODUTOS.CDFILIAL) AND
                (P.CDPRODUTO = C_PRODUTOS.CDPRODUTO) AND
                (P.DTPOSIESTQ <= SYSDATE)
        
         );
      
      V_VRYIELD := ROUND(100 - C_PRODUTOS.VRPEFATOCORR, 2);
      V_QTBRUTA := ROUND(C_PRODUTOS.QUANTIDADE / (1 - C_PRODUTOS.VRPEFATOCORR/100), 3);  
      
      V_VRCUSTOUNIT := CUSTO_PRODUTO_COC(C_PRODUTOS.CDFILIAL, C_PRODUTOS.CDPRODUTO, P_DATACUSTO, P_TIPOCUSTO);
      V_VRCUSTOTOTAL := ROUND(V_VRCUSTOUNIT * V_QTBRUTA, 2);
      
      INSERT INTO PRODPRODUCOC
      (NRPRODUCAOCOC, NRPRODPRODUCOC,
       CDPRODUTO, CDSETOR,
       NRRECPRODUCOC, QTPRODPRODUCOC,
       QTBRUTA, VRYIELD,
       QTESTOQUE, VRCUSTOUNIT, VRCUSTOTOTAL, DTULTATU)
      VALUES
      (P_NRPRODUCAOCOC, TO_NUMBER(V_NRPRODPRODUCOC),
       C_PRODUTOS.CDPRODUTO, NULL,
       NULL, C_PRODUTOS.QUANTIDADE,
       V_QTBRUTA, V_VRYIELD,
       V_QTESTOQUE, V_VRCUSTOUNIT, V_VRCUSTOTOTAL, SYSDATE);
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('COMPRAS_PREVSVCOC','5.85.xxx'); END;
/