/* Sistemas Integrados TEKNISA

Nome: 9505_CVIIEO_ETL_CONTAPAGDTENTR
Descrio: view que retorna AS CONTAS A PAGAR EM ABERTO POR DATA DE ENTRADA DA NF (ANO E MES)

Criao:
24/07/2012 - Ftima Fernandes
*/
CREATE OR REPLACE FORCE VIEW "DM_CONTAPAGDTENTR" ("CDEMPRESA", "CDFILIAL", "NMFILIALRECE", "NMFANTFORN", 
"NMRAZSOCFORN", "NMTIPOCONTA", "CDANOBI", "CDMESBI", "DSDOCSERIE", "DSDESCRICAO","DSSTCONTA", "VRBRUTOBOLETOPAG", 
"VRLIQUIDOBOLETOPAG", "VRAJUSTEBOLETOPAG", "VRORIGPAG", "VRAJUSTCTPAG", "VALORAPAGAR", "QTCONTAS","QTDIASVENCTO", 
"QTDIASATRASO", "QTBOLEMATRASO")
AS
SELECT  BO.CDEMPRESA, BO.CDFILIAL, F.CDFILIAL || '_' || F.NMFILIAL AS NMFILIALRECE,
        FO.NMFANTFORN, FO.NMRAZSOCFORN,
        CT.CDTPCTPAGAR|| '-' || DSTPCTPAGAR AS NMTIPOCONTA,
        TO_CHAR( NF.DTENTRSAID, 'YYYY') AS CDANOBI,
        TO_CHAR( NF.DTENTRSAID, 'MM') AS CDMESBI,
        (NF.NRNOTAFISC||'/'||NF.CDSERIEENTR||' - Entrada:'||NF.DTENTRSAID) DOC_SERIE,
        (CT.DSCONTAPAG) DESCRICAO,
        DECODE (NF.IDSTATUS,'V','PREVISTA','REAL') AS DSSTCONTA,
        (ROUND(BO.VRBOLPAG, 2)) AS VRBRUTOBOLETOPAG,
        (ROUND(BO.VRFINALBPAG, 2)) AS VRLIQUIDOBOLETOPAG,
        (ROUND(BO.VRFINALBPAG, 2) - ROUND(BO.VRBOLPAG, 2)) AS VRAJUSTEBOLETOPAG,
        SUM (ROUND(CT.VRORIGPAG, 2)) AS VRORIGPAG,
        SUM(ROUND(CT.VRATUAPAG,2) - ROUND(CT.VRORIGPAG,2)) AS VRAJUSTCTPAG,
        SUM (ROUND(CT.VRATUAPAG, 2) + ((BO.VRFINALBPAG - BO.VRBOLPAG) * (CT.VRATUAPAG/BO.VRBOLPAG))) AS VALORAPAGAR,
        COUNT(*) AS QTCONTAS,
        (TRUNC(BO.DTVENBOLPAG) - TRUNC(NF.DTENTRSAID)) AS  QTDIASVENCTO,
        (CASE WHEN TRUNC(BO.DTVENBOLPAG) < TRUNC(SYSDATE) THEN ROUND(TRUNC(SYSDATE) - TRUNC(BO.DTVENBOLPAG))  ELSE 0  END) QTDIASATRASO,
        (CASE WHEN TRUNC(BO.DTVENBOLPAG) < TRUNC(SYSDATE) THEN 1 ELSE 0 END) QTBOLEMATRASO
FROM CONTAPAGAR CT, BOLETPAGAR BO, FORNECEDOR FO, TIPOCTPAGAR TP, NOTAFISCAL NF, FILIAL F
WHERE    BO.CDFILIAL(+)    = CT.CDFILIBPAG
     AND BO.NRLANBOLPAG(+) = CT.NRLANBOLPAG
     AND CT.VRATUAPAG <> 0
     AND CT.IDSTATPAG ='A'
     AND FO.CDFORNECED = BO.CDFORNECED
     AND TP.CDTPCTPAGAR = CT.CDTPCTPAGAR
     AND CT.NRLANCTONF = NF.NRLANCTONF
     AND F.CDFILIAL    = NF.CDFILIRECE
     AND CT.CDFILIAL   = NF.CDFILIAL
     GROUP BY BO.CDEMPRESA, BO.CDFILIAL, F.CDFILIAL, F.NMFILIAL, 
     FO.NMFANTFORN, FO.NMRAZSOCFORN, CT.CDTPCTPAGAR, DSTPCTPAGAR,CT.DSCONTAPAG,
     NF.DTENTRSAID, NF.IDSTATUS, BO.VRBOLPAG, BO.VRFINALBPAG, BO.DTVENBOLPAG,NF.CDSERIEENTR,NF.NRNOTAFISC
/
BEGIN
--Fatos--	
	CRIA_FATOS('DM_CONTAPAGDTENTR', 'VRBRUTOBOLETOPAG'  ,'Vr. Brut. do Boleto'			,'Valor Bruto do Boleto'	      	,'Contas Pagas - Data de Entrada');
	CRIA_FATOS('DM_CONTAPAGDTENTR', 'VRLIQUIDOBOLETOPAG','Vr. Lq. do Bol.'			,'Valor Lquido do Boleto'	      	,'Contas Pagas - Data de Entrada');
	CRIA_FATOS('DM_CONTAPAGDTENTR', 'VRAJUSTEBOLETOPAG'	,'Vr. de Ajus. do Bol.'		,'Valor de Ajuste Boleto'	      	,'Contas Pagas - Data de Entrada');
	CRIA_FATOS('DM_CONTAPAGDTENTR', 'VRORIGPAG'			,'VrL. Orig. da Cont. a Pag.'	,'Valor Original da Conta a Pagar' 	,'Contas Pagas - Data de Entrada');
	CRIA_FATOS('DM_CONTAPAGDTENTR', 'VRAJUSTCTPAG'		,'VrL. de Ajust. Cont. a Pagar'	,'Valor de Ajuste de Contas a Pagar','Contas Pagas - Data de Entrada');
	CRIA_FATOS('DM_CONTAPAGDTENTR', 'VALORAPAGAR'		,'Valor a Pag.'					,'Valor a Pagar'		      		,'Contas Pagas - Data de Entrada');
	CRIA_FATOS('DM_CONTAPAGDTENTR', 'QTCONTAS'   		,'Quant. de Cont.'				,'Quantidade de Contas'		      	,'Contas Pagas - Data de Entrada');
	CRIA_FATOS('DM_CONTAPAGDTENTR', 'QTDIASVENCTO'		,'Dias para o Venc.'			,'Quantidade de Dias para o venc.'  ,'Contas Pagas - Data de Entrada');
	CRIA_FATOS('DM_CONTAPAGDTENTR', 'QTDIASATRASO'		,'Dias em Atraso'				,'Quantidade de Dias em o Atraso'   ,'Contas Pagas - Data de Entrada');
	CRIA_FATOS('DM_CONTAPAGDTENTR', 'QTBOLEMATRASO'    ,'Quant. de Bole. em atraso'	,'Quantidade de Boleto em o Atraso' ,'Contas Pagas - Data de Entrada');
		
--Dimenso--	
	CRIA_DIME('DM_CONTAPAGDTENTR'	,'CDEMPRESA'	,'Empresa'			,'EMPRESA','CDEMPRESA'	  ,'NMEMPRESA'	  ,NULL);
	CRIA_DIME('DM_CONTAPAGDTENTR'	,'CDFILIAL'	,'Filial'			,'FILIAL' ,'CDFILIAL' 	  ,'NMFILIAL' 	  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTENTR'	,'NMFILIALRECE'	,'Filial de Recebimento'	,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTENTR'	,'NMFANTFORN'	,'Nome Fantasia'		,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTENTR'	,'NMRAZSOCFORN'	,'Razo Social'			,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTAPAGDTENTR'	,'NMTIPOCONTA'	,'Tipo de Conta'		,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTAPAGDTENTR'	,'CDANOBI'	,'Ano'				,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTENTR'	,'CDMESBI'	,'Ms'				,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTAPAGDTENTR'	,'DSSTCONTA'	,'Situao da Conta'		,NULL	  ,NULL		  ,NULL		  ,NULL);
CRIA_DIME('DM_CONTAPAGDTENTR'	,'DSDOCSERIE'	,'Doc/Srie'		,NULL	  ,NULL		  ,NULL		  ,NULL);
CRIA_DIME('DM_CONTAPAGDTENTR'	,'DSDESCRICAO'	,'Descrio'		,NULL	  ,NULL		  ,NULL		  ,NULL);
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('DM_CONTAPAGDTENTR','5.09.105'); END;
/